--
-- small demonstrator for Lua binding on pixwerx
--

pw.script:load_all()

print("hello pixwerx!")

local w = pw.window.new()
w.visible = false

-- set title
w.title = "pixwerx 0.1"

-- set size
w.size = pw.size.new(640,480)

-- move window
w.position = pw.point.new(100,100)


local g = pw.geometry:new()

g.topology = pw.geometry.triangles -- meh


g.vertices:clear()

g.vertices:add(pw.vector3:new(-1, 1, 0)) -- 0
g.vertices:add(pw.vector3:new(-1,-1, 0)) -- 1
g.vertices:add(pw.vector3:new( 1,-1, 0)) -- 2
g.vertices:add(pw.vector3:new( 1, 1, 0)) -- 3


-- 0 --- 3
-- |  \  |
-- 1 --- 2

print(g.vertices,#g.vertices,g.vertices[1].x)

g.indices:add(0)
g.indices:add(1)
g.indices:add(2)

g.indices:add(2)
g.indices:add(3)
g.indices:add(0)

print(g.indices)


local mm = pw.matrix4x4:new()
local mv = pw.matrix4x4:new()
local mp = pw.matrix4x4:new()


w.visible = true


local fb = pw.framebuffer:new()

print(w.client_size.width,"x",w.client_size.height)

if fb:create(w.client_size) then
    print("framebuffer ok")
else
    print("framebuffer failed")
end



local s = pw.shader:new()

print(s.ready)

s:set_source(pw.shader_type.vertex,[[
#version 400
uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

in vec3 vertex_p;

void main() {
    gl_Position = projection * view * model * vec4(vertex_p, 1.0);
}
]])

s:set_source(pw.shader_type.fragment,[[
#version 400
uniform vec4 color = vec4(1.0, 0.0, 0.0, 1.0);
out vec4 frag_colour;
void main() {
    frag_colour = color;
}
]])

print(s.ready)

if not s:build() then
    print("Error!")
end

print(s.ready)

local renderer = pw.mesh_renderer:new()

if not renderer:create(g) then
    print("couldn't create renderer")
end


while w:update() do


    -- somehow works
    if (pw.input.get().input_string == 'f') then
        w.fullscreen = not w.fullscreen
    end

    -- keycode for quit
    if (pw.input.get().input_string == 'q') then
        break;
    end

    -- just to check
    if (pw.input:get().mouse_button == 1) then

        print("elapsed",t.elapsed)
            t:reset()
        print(pw.input:get().mouse_position.x,pw.input:get().mouse_position.y,w.client_size.width,w.client_size.height)
    end



    mm:set_identity()

    mv = pw.matrixtransform.look_at(pw.vector3:new(0,0,0),pw.vector3.forward(),pw.vector3.up())
    mp = pw.matrixtransform.perspective_projection(1.3,1.0,0.2,100)

    local cl = pw.vector4:new( 1.0, 0, 0, 1.0)



    s:use()

    s:set_uniform_mat4("model",mm)
    s:set_uniform_mat4("view",mv)
    s:set_uniform_mat4("projection",mp)
    s:set_uniform_vec4("color",cl)


    fb:bind()


    renderer:draw()

    fb:blit()

    fb:unbind()



end


